var search_data = {"index":{"searchIndex":["rom","changeset","associated","create","delete","extensions","relation","graph","pipe","piperegistry","stateful","update","plugins","relation","changeset","instancemethods",">>()","[]()","[]()","[]()","add_timestamps()","associate()","associate()","bind()","call()","changeset()","changeset()","clean?()","command()","command()","command()","command_compiler_options()","command_compiler_options()","commit()","commit()","commit()","commit()","compose()","data()","default_pipe()","diff()","diff?()","extend()","extend()","for_diff()","infer_assoc_name()","inherited()","initialize()","inspect()","inspect()","map()","map()","method_missing()","new()","new()","new()","original()","pipe()","pipes()","relation()","respond_to_missing?()","result()","to_a()","to_ary()","to_h()","to_hash()","touch()","use()"],"longSearchIndex":["rom","rom::changeset","rom::changeset::associated","rom::changeset::create","rom::changeset::delete","rom::changeset::extensions","rom::changeset::extensions::relation","rom::changeset::extensions::relation::graph","rom::changeset::pipe","rom::changeset::piperegistry","rom::changeset::stateful","rom::changeset::update","rom::plugins","rom::plugins::relation","rom::plugins::relation::changeset","rom::plugins::relation::changeset::instancemethods","rom::changeset::pipe#>>()","rom::changeset::[]()","rom::changeset::pipe::[]()","rom::changeset::pipe#[]()","rom::changeset::piperegistry::add_timestamps()","rom::changeset::associated#associate()","rom::changeset::stateful#associate()","rom::changeset::pipe#bind()","rom::changeset::pipe#call()","rom::changeset::extensions::relation::graph#changeset()","rom::plugins::relation::changeset::instancemethods#changeset()","rom::changeset::update#clean?()","rom::changeset#command()","rom::changeset::associated#command()","rom::changeset::create#command()","rom::changeset#command_compiler_options()","rom::changeset::stateful#command_compiler_options()","rom::changeset#commit()","rom::changeset::associated#commit()","rom::changeset::stateful#commit()","rom::changeset::update#commit()","rom::changeset::pipe#compose()","rom::changeset::stateful#data()","rom::changeset::stateful::default_pipe()","rom::changeset::update#diff()","rom::changeset::update#diff?()","rom::changeset::stateful::extend()","rom::changeset::stateful#extend()","rom::changeset::pipe#for_diff()","rom::changeset::associated::infer_assoc_name()","rom::changeset::stateful::inherited()","rom::changeset::pipe::initialize()","rom::changeset#inspect()","rom::changeset::stateful#inspect()","rom::changeset::stateful::map()","rom::changeset::stateful#map()","rom::changeset::stateful#method_missing()","rom::changeset#new()","rom::changeset::pipe::new()","rom::changeset::pipe#new()","rom::changeset::update#original()","rom::changeset::stateful#pipe()","rom::changeset::stateful::pipes()","rom::changeset::associated#relation()","rom::changeset::stateful#respond_to_missing?()","rom::changeset::stateful#result()","rom::changeset::stateful#to_a()","rom::changeset::stateful#to_ary()","rom::changeset::stateful#to_h()","rom::changeset::stateful#to_hash()","rom::changeset::piperegistry::touch()","rom::changeset::use()"],"info":[["ROM","","ROM.html","",""],["ROM::Changeset","","ROM/Changeset.html","","<p>Abstract Changeset class\n<p>If you inherit from this class you need to configure additional settings\n<p>@example …\n"],["ROM::Changeset::Associated","","ROM/Changeset/Associated.html","","<p>Associated changesets automatically set up FKs\n<p>@api public\n"],["ROM::Changeset::Create","","ROM/Changeset/Create.html","","<p>Changeset specialization for create commands\n<p>@see Changeset::Stateful\n<p>@api public\n"],["ROM::Changeset::Delete","","ROM/Changeset/Delete.html","","<p>Changeset specialization for delete commands\n<p>Delete changesets will execute delete command for its relation, …\n"],["ROM::Changeset::Extensions","","ROM/Changeset/Extensions.html","","<p>Namespace for changeset extensions\n<p>@api public\n"],["ROM::Changeset::Extensions::Relation","","ROM/Changeset/Extensions/Relation.html","",""],["ROM::Changeset::Extensions::Relation::Graph","","ROM/Changeset/Extensions/Relation/Graph.html","","<p>Changeset extenions for combined relations\n<p>@api public\n"],["ROM::Changeset::Pipe","","ROM/Changeset/Pipe.html","","<p>Composable data transformation pipe used by default in changesets\n<p>@api private\n"],["ROM::Changeset::PipeRegistry","","ROM/Changeset/PipeRegistry.html","","<p>Transproc Registry useful for pipe\n<p>@api private\n"],["ROM::Changeset::Stateful","","ROM/Changeset/Stateful.html","","<p>Stateful changesets carry data and can transform it into a different structure compatible with a persistence …\n"],["ROM::Changeset::Update","","ROM/Changeset/Update.html","","<p>Changeset specialization for update commands\n<p>Update changesets will only execute their commands when the …\n"],["ROM::Plugins","","ROM/Plugins.html","",""],["ROM::Plugins::Relation","","ROM/Plugins/Relation.html","",""],["ROM::Plugins::Relation::Changeset","","ROM/Plugins/Relation/Changeset.html","","<p>Relation plugin which adds `Relation#changeset` method\n<p>@api public\n"],["ROM::Plugins::Relation::Changeset::InstanceMethods","","ROM/Plugins/Relation/Changeset/InstanceMethods.html","","<p>Relation instance methods provided by the Changeset plugin\n<p>@api public\n"],[">>","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-i-3E-3E","(other, for_diff: other.is_a?(self.class) ? other.use_for_diff : false)",""],["[]","ROM::Changeset","ROM/Changeset.html#method-c-5B-5D","(relation_name)","<p>Create a changeset class preconfigured for a specific relation\n<p>@example\n\n<pre>class NewUserChangeset &lt; ROM::Changeset::Create[:users] ...</pre>\n"],["[]","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-c-5B-5D","(name_or_proc)",""],["[]","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-i-5B-5D","(*args)",""],["add_timestamps","ROM::Changeset::PipeRegistry","ROM/Changeset/PipeRegistry.html#method-c-add_timestamps","(data)",""],["associate","ROM::Changeset::Associated","ROM/Changeset/Associated.html#method-i-associate","(other, name = Associated.infer_assoc_name(other))","<p>Associate with other changesets\n<p>@see Changeset#associate\n<p>@return [Associated]\n"],["associate","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-associate","(other, name = Associated.infer_assoc_name(other))","<p>Associate a changeset with another changeset or hash-like object\n<p>@example with another changeset\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">new_user</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["bind","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-i-bind","(context)",""],["call","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-i-call","(data)",""],["changeset","ROM::Changeset::Extensions::Relation::Graph","ROM/Changeset/Extensions/Relation/Graph.html#method-i-changeset","(*)","<p>Build a changeset for a combined relation\n<p>@raise NotImplementedError\n<p>@api public\n"],["changeset","ROM::Plugins::Relation::Changeset::InstanceMethods","ROM/Plugins/Relation/Changeset/InstanceMethods.html#method-i-changeset","(type, data = EMPTY_HASH)","<p>Create a changeset for a relation\n<p>@overload changeset(type, data)\n\n<pre class=\"ruby\"><span class=\"ruby-constant\">Create</span> <span class=\"ruby-identifier\">a</span> <span class=\"ruby-identifier\">changeset</span> <span class=\"ruby-identifier\">of</span> <span class=\"ruby-identifier\">one</span> <span class=\"ruby-identifier\">of</span> <span class=\"ruby-identifier\">predefined</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["clean?","ROM::Changeset::Update","ROM/Changeset/Update.html#method-i-clean-3F","()","<p>Return if there&#39;s no diff between the original and changeset data\n<p>@return [TrueClass, FalseClass] …\n"],["command","ROM::Changeset","ROM/Changeset.html#method-i-command","()","<p>Return a command for this changeset\n<p>@return [ROM::Command]\n<p>@api private\n"],["command","ROM::Changeset::Associated","ROM/Changeset/Associated.html#method-i-command","()","<p>Create a composed command\n<p>@example using existing parent data\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">user_changeset</span> = <span class=\"ruby-identifier\">users</span>.<span class=\"ruby-identifier\">changeset</span>(<span class=\"ruby-value\">name:</span> <span class=\"ruby-string\">&#39;Jane&#39;</span>) <span class=\"ruby-operator\">...</span>\n</pre>\n"],["command","ROM::Changeset::Create","ROM/Changeset/Create.html#method-i-command","()",""],["command_compiler_options","ROM::Changeset","ROM/Changeset.html#method-i-command_compiler_options","()","<p>Return configured command compiler options\n<p>@return [Hash]\n<p>@api private\n"],["command_compiler_options","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-command_compiler_options","()","<p>@api private\n"],["commit","ROM::Changeset","ROM/Changeset.html#method-i-commit","()","<p>Persist changeset\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-identifier\">changeset</span> = <span class=\"ruby-identifier\">users</span>.<span class=\"ruby-identifier\">changeset</span>(<span class=\"ruby-value\">name:</span> <span class=\"ruby-string\">&#39;Jane&#39;</span>)\n<span class=\"ruby-identifier\">changeset</span>.<span class=\"ruby-identifier\">commit</span>\n<span class=\"ruby-comment\"># =&gt; { id: 1, name: ...</span>\n</pre>\n"],["commit","ROM::Changeset::Associated","ROM/Changeset/Associated.html#method-i-commit","()","<p>Commit changeset&#39;s composite command\n<p>@example\n\n<pre>task_changeset = tasks.\n  changeset(title: &#39;Task One&#39;). ...</pre>\n"],["commit","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-commit","()","<p>Commit stateful changeset\n<p>@see Changeset#commit\n<p>@api public\n"],["commit","ROM::Changeset::Update","ROM/Changeset/Update.html#method-i-commit","()","<p>Commit update changeset if there&#39;s a diff\n<p>This returns original tuple if there&#39;s no diff\n<p>@return …\n"],["compose","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-i-compose","(other, for_diff: other.is_a?(self.class) ? other.use_for_diff : false)",""],["data","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-data","(data)","<p>Return changeset with data\n<p>@param [Hash] data\n<p>@return [Changeset]\n"],["default_pipe","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-c-default_pipe","(context)","<p>Build default pipe object\n<p>This can be overridden in a custom changeset subclass\n<p>@return [Pipe]\n"],["diff","ROM::Changeset::Update","ROM/Changeset/Update.html#method-i-diff","()","<p>Calculate the diff between the original and changeset data\n<p>@return [Hash]\n<p>@api public\n"],["diff?","ROM::Changeset::Update","ROM/Changeset/Update.html#method-i-diff-3F","()","<p>Return true if there&#39;s a diff between original and changeset data\n<p>@return [TrueClass, FalseClass] …\n"],["extend","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-c-extend","(*, &block)","<p>Define a changeset mapping excluded from diffs\n<p>@see Changeset::Stateful.map @see Changeset::Stateful#extend …\n"],["extend","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-extend","(*steps, **options, &block)","<p>Pipe changeset&#39;s data using custom steps define on the pipe. You should use #map instead except updating …\n"],["for_diff","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-i-for_diff","(data)",""],["infer_assoc_name","ROM::Changeset::Associated","ROM/Changeset/Associated.html#method-c-infer_assoc_name","(other)","<p>Infer association name from an object with a schema\n<p>This expects other to be an object with a schema that …\n"],["inherited","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-c-inherited","(klass)","<p>@api private\n"],["initialize","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-c-initialize","(**opts)",""],["inspect","ROM::Changeset","ROM/Changeset.html#method-i-inspect","()","<p>Return string representation of the changeset\n<p>@return [String]\n<p>@api public\n"],["inspect","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-inspect","()","<p>Return string representation of the changeset\n<p>@return [String]\n<p>@api public\n"],["map","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-c-map","(**options, &block)","<p>Define a changeset mapping\n<p>Subsequent mapping definitions will be composed together and applied in the …\n"],["map","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-map","(*steps, &block)","<p>Pipe changeset&#39;s data using custom steps define on the pipe\n<p>@overload map(*steps)\n\n<pre class=\"ruby\"><span class=\"ruby-constant\">Apply</span> <span class=\"ruby-identifier\">mapping</span> <span class=\"ruby-identifier\">using</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["method_missing","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-method_missing","(meth, *args, &block)","<p>@api private\n"],["new","ROM::Changeset","ROM/Changeset.html#method-i-new","(relation, **new_options)","<p>Return a new changeset with provided relation\n<p>New options can be provided too\n<p>@param [Relation] relation …\n"],["new","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-c-new","(*args, **opts)",""],["new","ROM::Changeset::Pipe","ROM/Changeset/Pipe.html#method-i-new","(processor, **opts)",""],["original","ROM::Changeset::Update","ROM/Changeset/Update.html#method-i-original","()","<p>Return original tuple that this changeset may update\n<p>@return [Hash]\n<p>@api public\n"],["pipe","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-pipe","()","<p>Data transformation pipe\n<p>@return [Changeset::Pipe]\n<p>@api private\n"],["pipes","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-c-pipes","()","<p>@api private\n"],["relation","ROM::Changeset::Associated","ROM/Changeset/Associated.html#method-i-relation","()","<p>@api private\n"],["respond_to_missing?","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-respond_to_missing-3F","(meth, include_private = false)","<p>@api private\n"],["result","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-result","()","<p>Return command result type\n<p>@return [Symbol]\n<p>@api private\n"],["to_a","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-to_a","()","<p>Coerce changeset to an array\n<p>This will send the data through the pipe\n<p>@return [Array]\n"],["to_ary","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-to_ary","()",""],["to_h","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-to_h","()","<p>Coerce changeset to a hash\n<p>This will send the data through the pipe\n<p>@return [Hash]\n"],["to_hash","ROM::Changeset::Stateful","ROM/Changeset/Stateful.html#method-i-to_hash","()",""],["touch","ROM::Changeset::PipeRegistry","ROM/Changeset/PipeRegistry.html#method-c-touch","(data)",""],["use","ROM::Changeset","ROM/Changeset.html#method-c-use","(plugin, **options)","<p>Enable a plugin for the changeset\n<p>@api public\n"]]}}